/* Community forum question about transpose */
/* https://communities.sas.com/message/189755#189755 */  

data ex1;
  length Study $5 Category $9;
  infile datalines;
  input study $ datetime : date7. category $ value;
return;
datalines;
x 01Jan13 Category1 10 
x 01Jan13 Category2 20 
x 01Jan13 Category3 30 
x 01Jan13 Category4 40  
x 07Jan13 Category1 20 
x 07Jan13 Category3 40   
x 14Jan13 Category2 27 
y 03Jan13 Category1 15 
y 04Jan13 Category1 25 
y 01Jan13 Category3 35 
y 03Jan13 Category4 45  
y 09Jan13 Category1 25 
y 09Jan13 Category3 45   
y 14Jan13 Category2 29 
;
run;
  
ods _all_ close;
title; footnote;
    
ods html file='c:\temp\want_report.html' style=sasweb;
 
proc tabulate data=ex1 f=comma6.;
  title '1) PROC TABULATE';
  class study datetime category;
  var value;
  table study*Category all*{style=Header},
        datetime='Date'*value=' ' all*value=' ';
  keylabel sum=' '
           all='Total';
  keyword all / style={vjust=b};
  format datetime date7.;
run;
  
proc report data=ex1 nowd
  style(summary)=Header;
  title '2) PROC REPORT';
  column study category value,datetime value=tot;
  define study / group style(column)=Header;
  define category / group style(column)=Header;
  define datetime /across order=internal f=date7. 'Date';
  define value / analysis sum f=comma6. ' ';
  define tot / analysis sum 'Total' f=comma6. ;
  rbreak after / summarize;
  compute after;
    study='Total';
  endcomp;
run;

ods html close;


** alternate example with variables in a different order;
ods html file='c:\temp\alt_comma.html' style=sasweb;

proc report data=ex1 nowd
  style(summary)=Header;
  where category in ('Category1', 'Category2');
  title '3a) PROC REPORT';
  column study category datetime,value value=tot;
  define study / group style(column)=Header;
  define category / group style(column)=Header;
  define datetime /across order=internal f=date7. 'Date';
  define value / analysis sum f=comma6. ' ';
  define tot / analysis sum 'Total' f=comma6. ;
  rbreak after / summarize;
  compute after;
    study='Total';
  endcomp;
run;

proc report data=ex1 nowd
  style(summary)=Header;
  where category in ('Category1', 'Category2');
  title '3b) PROC REPORT';
  column study category datetime,value value=tot;
  define study / group style(column)=Header;
  define category / group style(column)=Header;
  define datetime /across order=internal f=date7. 'Date';
  define value / analysis sum f=comma6. 'Value';
  define tot / analysis sum 'Total' f=comma6. ;
  rbreak after / summarize;
  compute after;
    study='Total';
  endcomp;
run;

proc report data=ex1 nowd
  style(summary)=Header;
  where category in ('Category1', 'Category2');
  title '3c) PROC REPORT';
  column ('Study' study) ('Category' category) datetime,value ('Total' value=tot);
  define study / group style(column)=Header ' ';
  define category / group style(column)=Header ' ';
  define datetime /across order=internal f=date7. 'Date';
  define value / analysis sum f=comma6. ' ';
  define tot / analysis sum ' ' f=comma6. ;
  rbreak after / summarize;
  compute after;
    study='Total';
  endcomp;
run;

ods html close;
