/* Using Character variables with ACROSS */
/* https://communities.sas.com/message/168440#168440 */

data ex2;
input (League Team Captain) ($);
datalines;
N A Alan
N B Bob
N C Charles
S A David
S B Edward
S C Frank
;
run;
  
ods html file='c:\temp\Example_2.html';
 
proc report data=ex2 nowd;
  title '1st try';
  column league team,captain;
  define league / group;
  define team / across;
  define captain / display;
run;

proc report data=ex2 nowd;
  title '1st try with statistic';
  column league team,captain;
  define league / group;
  define team / across;
  define captain / n 'Count';
run;
   
proc report data=ex2 nowd;
  title1 '2nd try with dummyvar';
  column league team,captain dummyvar;
  define league / group;
  define team / across;
  define captain / display;
  define dummyvar / computed /* noprint */;
  compute dummyvar;
    dummyvar = 1;
  endcomp;
run;

proc report data=ex2 nowd;
  title1 'Final Report';
  column ('League' league) team,captain dummyvar;
  define league / group ' ';
  define team / across 'Team';
  define captain / display ' ';
  define dummyvar / computed  noprint ' ' ;
  compute dummyvar;
    dummyvar = 1;
  endcomp;
run;

   
proc report data=ex2 nowd;
  title1 'Use N instead of DUMMYVAR';
  column league team,captain n;
  define league / group;
  define team / across;
  define captain / display;
  define n / 'Count' /* noprint */;
run;
   
proc report data=ex2 nowd;
  title1 'Use N with ORDER';
  column league team,captain n;
  define league / order;
  define team / across;
  define captain / display;
  define n / 'Count' /* noprint */;
run;
   
proc report data=ex2 nowd;
  title1 'Use ORDER with DUMMYVAR';
  column league team,captain dummyvar;
  define league / order;
  define team / across;
  define captain / display;
  define dummyvar / computed /* noprint */;
  compute dummyvar;
    dummyvar = 1;
  endcomp;
run;

ods html close;
