ods _all_ close;

ods html file='c:\temp\demo3_ex_start.html';
  proc report data=sashelp.class nowd out=abscols
    style(summary)=Header;
    where age le 13;
    title '1) Proc Report Crosstab Report';
    column age ( sex,(weight height))
               ('Overall' weight=wta height=hta);
    define age / group
           style(column)=Header;
    define sex / across 'Gender Avg';
    define weight / mean f=7.2;
    define height / mean f=7.2;
    define wta / mean f=7.2 style(column)=Header;
    define hta / mean f=7.2 style(column)=Header;
    rbreak after / summarize;
  run;
ods _all_ close; 

  ods listing close;
  ods html file='c:\temp\ex3_see_abs_cols.html';
  proc print data=abscols;
    title 'What Are Absolute Column Names';
  run;  
  ods html close;


ods html file='c:\temp\demo3_ex_calc.html';
  proc report data=sashelp.class nowd 
    style(summary)=Header;
    where age le 13;
    title '2a) Proc Report with Calculated Column Specified Incorrectly';
    column age ( sex,(weight height Diff))
               ('Overall' weight=wta height=hta Diffa);
    define age / group
           style(column)=Header;
    define sex / across 'Gender Avg';
    define weight / mean f=7.2;
    define height / mean f=7.2;
	define diff / computed f=7.2;
    define wta / mean f=7.2 style(column)=Header;
    define hta / mean f=7.2 style(column)=Header;
	define diffa / computed f=7.2 style(column)=Header;
	compute diff;
	  diff = weight.mean - height.mean ;
    endcomp;
	compute diffa;
	  diffa = wta - hta;
	endcomp;
    rbreak after / summarize;
  run;

  proc report data=sashelp.class nowd 
    style(summary)=Header;
    where age le 13;
    title '2b) Proc Report with Calculated Column Specified Correctly';
    column age ( sex,(weight height Diff))
               ('Overall' weight=wta height=hta Diffa);
    define age / group
           style(column)=Header;
    define sex / across 'Gender Avg';
    define weight / mean f=7.2;
    define height / mean f=7.2;
	define diff / computed f=7.2;
    define wta / mean f=7.2 style(column)=Header;
    define hta / mean f=7.2 style(column)=Header;
	define diffa / computed f=7.2 style(column)=Header;
	compute diff;
	  _c4_ = _c2_ - _c3_;
	  _c7_ = _c5_ - _c6_;
    endcomp;
	compute diffa;
	  diffa = wta - hta;
	endcomp;
    rbreak after / summarize;
  run;

ods html close;    



** How to use Absolute Column numbers to calculate items with ACROSS usage;
** and change the style with CALL DEFINE and a custom background based on the cell value;
proc format;
  value fpct low-<.95='lightyellow'
              .95-<1.00 = 'lightblue'
             1.00-<1.075 = 'lightpink'
             1.075-<1.10='lavender'
             1.10-<1.50 = 'peachpuff'
             1.50-high='verylightgreen';
run;
   
ods html file='c:\temp\demo4_change_style.html';

proc report data=sashelp.prdsale nowd;
  title '3) Using ACROSS items and calculating report items and changing style';
  column country division product,(actual predict pctcalc);
  define country / group;
  define division / group;
  define product / across;
  define actual / sum;
  define predict / sum;
  define pctcalc / computed 'Pct of Predict' f=percent9.2 
         style(column)={background=fpct.};
  compute pctcalc;
    length svar5 svar8 svar11 svar14 svar17  $50;
    _c5_ = _c3_ / _c4_;
    _c8_ = _c6_ / _c7_;
    _c11_ = _c9_ / _c10_;
    _c14_ = _c12_ / _c13_;
    _c17_ = _c15_ / _c16_;
    svar5 = 'style={background='||put(_c5_,fpct.)||'}';
    svar8 = 'style={background='||put(_c8_,fpct.)||'}';
    svar11 = 'style={background='||put(_c11_,fpct.)||'}';
    svar14 = 'style={background='||put(_c14_,fpct.)||'}';
    svar17 = 'style={background='||put(_c17_,fpct.)||'}';
    call define('_c3_','style',svar5);
    call define('_c4_','style',svar5);
    call define('_c6_','style',svar8);
    call define('_c7_','style',svar8);
    call define('_c9_','style',svar11);
    call define('_c10_','style',svar11);
    call define('_c12_','style',svar14);
    call define('_c13_','style',svar14);
    call define('_c15_','style',svar17);
    call define('_c16_','style',svar17);
  endcomp;
run;

ods html close;
title;




