

ods html file='c:\temp\demo4_start.html';
proc report data=sashelp.prdsale nowd;
  title '1) Starting Report';
  column country division product,(actual predict);
  define country / group;
  define division / group;
  define product / across;
  define actual / sum;
  define predict / sum;
run;

ods html close;
title;

ods html file='c:\temp\demo4_change_hdr.html';
proc report data=sashelp.prdsale nowd;
  title '2a) Using Spanning Headers and changing style ';
  column ('Group Variables' country division) product,(actual predict);
  define country / group style(header)={background=lightgreen};
  define division / group style(header)={background=lightgreen};
  define product / across ' ' style(header)={background=lightyellow};
  define actual / sum style(header)={background=lightyellow};
  define predict / sum style(header)={background=lightyellow};
run;

proc report data=sashelp.prdsale nowd
  style(header)={background=lightgreen};
  title '2b) Using Spanning Headers and changing style ';
  title2 'The usual way to change if you want all headers to be the same color';
  column ('Group Variables' country division) product,(actual predict);
  define country / group;
  define division / group;
  define product / across ' ' style(header)={background=lightyellow};
  define actual / sum style(header)={background=lightyellow};
  define predict / sum style(header)={background=lightyellow};
run;


proc report data=sashelp.prdsale nowd
  style(header)={background=lightgreen};
  title '2c) Using Multiple Spanning Headers and changing style ';
  title2 'The usual way to change if you want all headers to be the same color';
  column ('Three Values' country) ('Current' division) product,(actual predict);
  define country / group;
  define division / group;
  define product / across ' ' style(header)={background=lightyellow};
  define actual / sum style(header)={background=lightyellow};
  define predict / sum style(header)={background=lightyellow};
run;


ods html close;
title;

data prdsale;
  length x y fakevar fakediv $25;
  set sashelp.prdsale;
  x='Three Values';
  y='Current';
  fakevar = country;
  fakediv = division;
run;
  
ods html file='c:\temp\demo4_change_hdr_with_across.html';
proc report data=prdsale nowd out=abscol;
  title '3) Alternate way to change spanning headers using ACROSS items and changing headers ';
  column fakevar fakediv x,(country) y,(division) product,(actual predict);
  define fakevar / group noprint ' ';
  define fakediv / group noprint ' ';
  define x / across ' ' style(header)={background=lightgreen};
  define country / group style(header)={background=lightgreen};
  define y / across ' ' style(header)={background=peachpuff};
  define division / group style(header)={background=peachpuff};
  define product / across ' ' style(header)={background=lightyellow};
  define actual / sum style(header)={background=lightyellow};
  define predict / sum style(header)={background=lightyellow};
run;
  
proc report data=prdsale nowd out=abscol;
  title '3b) Fix values for Country and Division using Absolute Column Numbers';
  column fakevar fakediv x,(country) y,(division) product,(actual predict);
  define fakevar / group noprint ' ';
  define fakediv / group noprint ' ';
  define x / across ' ' style(header)={background=lightgreen};
  define country / group style(header)={background=lightgreen};
  define y / across ' ' style(header)={background=peachpuff};
  define division / group style(header)={background=peachpuff};
  define product / across ' ' style(header)={background=lightyellow};
  define actual / sum style(header)={background=lightyellow};
  define predict / sum style(header)={background=lightyellow};
  compute country;
    _c3_ = fakevar;
  endcomp;
  compute division;
    _c4_ = fakediv;
  endcomp;
run;

ods html close;
title;
