** Bonus: macroized version of the program;
%macro wantprod(startcol=3, varsleft=2, varsunder=3);
  /* STARTCOL: the position of the first computed var under the across */
  /* VARSLEFT: the number of variables before the across */
  /* VARSUNDER: number of variables under the across */
  /* NUM: is the number of unique ACROSS variable values */
options mprint mlogic;


proc sql;
  select count(distinct product) into :num 
  from sashelp.prdsale;
quit;

%put number of products is: &num;
    
ods listing close;
ods html file="c:\temp\demo3_macroize.html";

proc report data=sashelp.prdsale nowd;
  title '4) Using ACROSS items and calculating report items and changing style';
  column country division product,(actual predict pctcalc);
  define country / group;
  define division / group;
  define product / across;
  define actual / sum;
  define predict / sum;
  define pctcalc / computed 'Pct of Predict' f=percent9.2 
         style(column)={background=fpct.};

COMPUTE pctcalc;
%DO i=&startcol %TO %EVAL(&num*&varsunder+&varsleft) %BY &varsunder;
  _C%EVAL(&i+2)_=_C%EVAL(&i)_ / _C%EVAL(&i+1)_;
  length svar%eval(&i+2) $50.;
  svar%eval(&i+2) = 'style={background='||put(_C%EVAL(&i+2)_,fpct.)||'}';
  call define("_C%EVAL(&i)_",'style',svar%eval(&i+2));
  call define("_C%EVAL(&i+1)_",'style',svar%eval(&i+2));
%END;
ENDCOMP;
RUN;

ods html close;
title;
%mend wantprod;

** invoke macro program;
%wantprod(startcol=3, varsleft=2, varsunder=3)
