** Highlight with multiple items For COUNTRY and PRODUCT, which is ACROSS;
** so trafficlight for CANADA where PRODUCT is CHAIR or DESK;
proc format;
  value ovrpct 1.00-<1.075 = 'lightpink'
             1.075-<1.10='lavender'
             1.10-<1.50 = 'peachpuff'
             1.50-high='verylightgreen'
             .,other = 'white';
run;
   
ods _all_ close;
ods html file='c:\temp\demo5_change_style.html';

proc report data=sashelp.prdsale nowd;
  title '1) Highlight based on ACROSS item and GROUP item';
  column country division product,(actual predict pctcalc);
  define country / group f=$char10.;
  define division / group;
  define product / across;
  define actual / sum;
  define predict / sum;
  define pctcalc / computed 'Pct of Predict' f=percent9.2;
  compute before country;
    length altcountry $10;
	altcountry = country;
  endcomp;

  compute pctcalc;
    length  svar8 svar11 $50 altcountry $10;
    _c5_ = divide(_c3_ , _c4_); 
    _c8_ = divide(_c6_ , _c7_);
    _c11_ = divide(_c9_ , _c10_);
    _c14_ = divide(_c12_ , _c13_);
    _c17_ = divide(_c15_ , _c16_);
	if _c5_ gt 1.0 then do; call define('_c5_','style','style={foreground=green background=white fontweight=bold}'); end;
	else do;  call define('_c5_','style','style={foreground=black background=white fontweight=medium}'); end;
	if _c14_ gt 1.0 then do; call define('_c14_','style','style={foreground=green background=white fontweight=bold}'); end;
	else do; call define('_c14_','style','style={foreground=black background=white fontweight=medium}'); end;
	if _c17_ gt 1.0 then do; call define('_c17_','style','style={foreground=green background=white fontweight=bold}'); end;
	else do; call define('_c17_','style','style={foreground=black background=white fontweight=medium}');end;

	if altcountry in ('GERMANY', 'U.S.A.') then do;
	    if _c8_ gt 1.0 then call define('_c8_','style','style={foreground=green background=white fontweight=bold}');
	    else call define('_c8_','style','style={foreground=black background=white fontweight=medium}');
	    if _c11_ gt 1.0 then call define('_c11_','style','style={foreground=green background=white fontweight=bold}');
	    else call define('_c11_','style','style={foreground=black background=white fontweight=medium}');
	 end;
	else if altcountry = 'CANADA' and (_c8_ gt 1.0 or _c11_ gt 1.0) then do;
	     ** only want to highlight CHAIR and DESK for Canada as shown in previous report;
         svar8 = 'style={background=' || put(_c8_,ovrpct.)||'}';
         svar11 = 'style={background=' || put(_c11_,ovrpct.)||'}';
         call define('_c6_','style',svar8);
         call define('_c7_','style',svar8);
         call define('_c8_','style',svar8);
         call define('_c9_','style',svar11);
         call define('_c10_','style',svar11);
         call define('_c11_','style',svar11);
	 end; 
  endcomp;
run;
ods html close;
  
ods html file='c:\temp\demo5_show_abs.html';
proc report data=sashelp.prdsale nowd out=show_abs;
  title '2) How to Reveal Absolute Column Numbers';
  column country division product,(actual predict pctcalc);
  define country / group f=$char10.;
  define division / group;
  define product / across;
  define actual / sum;
  define predict / sum;
  define pctcalc / computed 'Pct of Predict' f=percent9.2;
  compute pctcalc;
    _c5_ = divide(_c3_ , _c4_); 
    _c8_ = divide(_c6_ , _c7_);
    _c11_ = divide(_c9_ , _c10_);
    _c14_ = divide(_c12_ , _c13_);
    _c17_ = divide(_c15_ , _c16_);
  endcomp;
run;  

proc print data=show_abs noobs;
title 'What Are Absolute Columns';
run;
ods html close;
title;
