** Highlight with multiple items For COUNTRY and PRODUCT, which is ACROSS;
** so trafficlight for CANADA where PRODUCT is CHAIR or DESK;
proc format;
  value fpct 1.00-<1.075 = 'lightpink'
             1.075-<1.10='lavender'
             1.10-<1.50 = 'peachpuff'
             1.50-high='verylightgreen'
             other = 'white';
run;
   
** shows a slightly different approach to testing for Germany and US;
** by using a temporary variable created with a SUBSTR function;
ods html file='c:\temp\demo5_change_style.html';

proc report data=sashelp.prdsale nowd;
  title '1) Highlight based on ACROSS item and GROUP item';
  column country division product,(actual predict pctcalc);
  define country / group f=$char10.;
  define division / group;
  define product / across;
  define actual / sum;
  define predict / sum;
  define pctcalc / computed 'Pct of Predict' f=percent9.2;
  compute before country;
    length holdcountry $1;
    holdcountry=substr(country,1,1);
  endcomp;

  compute pctcalc;
    length  svar8 svar11  $50;
    _c5_ = _c3_ / _c4_;
    _c8_ = _c6_ / _c7_;
    _c11_ = _c9_ / _c10_;
    _c14_ = _c12_ / _c13_;
    _c17_ = _c15_ / _c16_;
	** only want to highlight CHAIR and DESK for Canada as shown in previous report;
	if holdcountry = 'C' and (_c8_ gt 1.0 or _c11_ gt 1.0) then do; /* IF1 */
         svar8 = 'style={background=' || put(_c8_,fpct.)||'}';
         svar11 = 'style={background=' || put(_c11_,fpct.)||'}';
         call define('_c6_','style',svar8);
         call define('_c7_','style',svar8);
         call define('_c8_','style',svar8);
         call define('_c9_','style',svar11);
         call define('_c10_','style',svar11);
         call define('_c11_','style',svar11);
	 end;  /* end IF 1 */
	 else if holdcountry in ('G', 'U') then do;
	    if _c8_ gt 1.0 then call define('_c8_','style','style={foreground=green background=white fontweight=bold}');
	    else call define('_c8_','style','style={foreground=black background=white fontweight=medium}');
	    if _c11_ gt 1.0 then call define('_c11_','style','style={foreground=green background=white fontweight=bold}');
	    else call define('_c11_','style','style={foreground=black background=white fontweight=medium}');
	 end;
	 if _c5_ gt 1.0 then do; call define('_c5_','style','style={foreground=green background=white fontweight=bold}'); end;
	 else do;  call define('_c5_','style','style={foreground=black background=white fontweight=medium}'); end;
	 if _c14_ gt 1.0 then do; call define('_c14_','style','style={foreground=green background=white fontweight=bold}'); end;
	 else do; call define('_c14_','style','style={foreground=black background=white fontweight=medium}'); end;
	 if _c17_ gt 1.0 then do; call define('_c17_','style','style={foreground=green background=white fontweight=bold}'); end;
	 else do; call define('_c17_','style','style={foreground=black background=white fontweight=medium}');end;
  endcomp;
run;

ods html close;
title;
