ods html file='c:\temp\demo6_order_across_examp.html';
  proc report data=sashelp.class nowd 
    style(summary)=Header;
    title '1a) Ascending Report is Default for AGE';
    column sex ( age,(height weight));
    define sex / group
           style(column)=Header;
    define age / across 'Gender Avg';
    define height / mean f=7.2;
    define weight / mean f=7.2;
    rbreak after / summarize;
  run;
   
  proc report data=sashelp.class nowd 
    style(summary)=Header;
    title '1b) Descending Report';
    column sex ( age,(height weight));
    define sex / group
           style(column)=Header;
    define age / across 'Gender Avg' descending;
    define height / mean f=7.2;
    define weight / mean f=7.2;
    rbreak after / summarize;
  run;
     
  ** sort by name will force different order for AGE;
  proc sort data=sashelp.class out=class;
    by name;
  run;
         
  proc print data=class;
  title '2a) what order is AGE after sort-- note that 14 is first, then 13, then 12, then 15';
  run;
       
  proc report data=class nowd 
    style(summary)=Header;
    title '2b) ORDER=DATA  Report';
	title2 'Columns are in the order that AGE appears in sorted data';
    column sex ( age,(height weight));
    define sex / group
           style(column)=Header;
    define age / across 'Gender Avg' order=data;
    define height / mean f=7.2;
    define weight / mean f=7.2;
    rbreak after / summarize;
  run;
       
  proc report data=class nowd 
    style(summary)=Header;
    title '3) ORDER=DATA with Descending Report';
	title2 'Columns are in descending order of the data order';
    column sex ( age,(height weight));
    define sex / group
           style(column)=Header;
    define age / across 'Gender Avg' order=data descending;
    define height / mean f=7.2;
    define weight / mean f=7.2;
    rbreak after / summarize;
  run;
 
ods _all_ close; 
title; footnote;
